routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::prefix('admin')->middleware('auth')->group(function () {
    //User
    Route::get('quan-tri','AdminController@index')->name('admin.index');
    Route::get('list-user','UserController@index')->name('user.index')->middleware(['can:view-user']); //danh sách user
    Route::get('create-user','UserController@create')->name('user.create')->middleware(['can:create-user']);  //tạo mới user
    Route::post('store-user','UserController@store')->name('user.store');
    Route::get('edit-user/{id}','UserController@edit')->name('user.edit')->middleware(['can:edit-user']); //Sửa user
    Route::post('update-user/{id}','UserController@update')->name('user.update');
    Route::delete('delete-user/{id}','UserController@destroy')->name('user.destroy')->middleware(['can:delete-user']); //Xóa user
   // Recruitment
    Route::get('list-recruitment','RecruitmentController@index')->name('recruitment.index')->middleware(['can:view-recruitment']);
    Route::get('create-recruitment','RecruitmentController@create')->name('recruitment.create')->middleware(['can:create-recruitment']);
    Route::post('store-recruitment','RecruitmentController@store')->name('recruitment.store');
    Route::get('edit-recruitment/{id}','RecruitmentController@edit')->name('recruitment.edit')->middleware(['can:edit-recruitment']);
    Route::post('update-recruitment/{id}','RecruitmentController@update')->name('recruitment.update');
    Route::delete('delete-recruitment/{id}','RecruitmentController@destroy')->name('recruitment.destroy')->middleware(['can:delete-recruitment']);//danh sách recruitment
    // Candidate
    Route::get('list-candidate','CandidateController@index')->name('candidate.index')->middleware(['can:view-candidate']);
//    Route::get('/admin/candidate/{id}', 'CandidateController@show')->name('candidate.show');
    Route::get('create-candidate','CandidateController@create')->name('candidate.create')->middleware(['can:create-candidate']);
    Route::post('store-candidate','CandidateController@store')->name('candidate.store');
    Route::get('edit-candidate/{id}','CandidateController@edit')->name('candidate.edit')->middleware(['can:edit-candidate']);
    Route::post('update-candidate/{id}','CandidateController@update')->name('candidate.update');
    Route::delete('delete-candidate/{id}','CandidateController@destroy')->name('candidate.destroy')->middleware(['can:delete-candidate']);
    //// Interview
    Route::get('list-interview','InterviewController@index')->name('interview.index')->middleware(['can:view-interview']);
    Route::get('create-interview','InterviewController@create')->name('interview.create')->middleware(['can:create-interview']);
    Route::post('store-interview','InterviewController@store')->name('interview.store');
    Route::get('edit-interview/{id}','InterviewController@edit')->name('interview.edit')->middleware(['can:edit-interview']);
    Route::post('update-interview/{id}','InterviewController@update')->name('interview.update');
    Route::delete('delete-interview/{id}','InterviewController@destroy')->name('interview.destroy')->middleware(['can:delete-interview']);
    // Job
    Route::get('list-job','JobController@index')->name('job.index')->middleware(['can:view-job']);
    //Job_candidate
    Route::get('job/{id}/job_candidate','JobController@job_create')->name('job.job_candidate.create');
    Route::post('store-job/job_candidate','JobController@job_store')->name('job.job_candidate.store');
    Route::get('list-job/{id}/job_candidate','JobController@job_index')->name('job.job_candidate.index');
    Route::get('list-candidate/{id}/job_candidate','JobController@job_list')->name('job.job_candidate.list');
    Route::get('job/{id}/add-candidate', 'JobController@addJobCandidate')->name('add.job.candidate');

    //end job_candidate
    Route::get('create-job','JobController@create')->name('job.create')->middleware(['can:create-job']);
    Route::post('store-job','JobController@store')->name('job.store');
    Route::get('edit-job/{id}','JobController@edit')->name('job.edit')->middleware(['can:edit-job']);
    Route::post('update-job/{id}','JobController@update')->name('job.update');
    Route::delete('delete-job/{id}','JobController@destroy')->name('job.destroy')->middleware(['can:delete-job']);
    // Role
    Route::get('list-role','RoleController@index')->name('role.index')->middleware(['can:view-role']);
    Route::get('create-role','RoleController@create')->name('role.create')->middleware(['can:create-role']);
    Route::post('store-role','RoleController@store')->name('role.store');
    Route::get('edit-role/{id}','RoleController@edit')->name('role.edit')->middleware(['can:edit-role']);
    Route::post('update-role/{id}','RoleController@update')->name('role.update');
    Route::delete('delete-role/{id}','RoleController@destroy')->name('role.destroy')->middleware(['can:delete-role']);

    //Work-Process
    Route::get('work-process/index','WorkProcessController@index')->name('process.candidate.index');
    Route::get('work-process/create','WorkProcessController@create')->name('process.candidate.create');
    Route::post('work-process/store','WorkProcessController@store')->name('process.candidate.store');

});
//Authenciation
//Route::get('/register-auth','AuthController@register')->name('register');
//Route::resource('role', 'RoleController')->middleware(['can:view-role','can:create-role','can:edit-role','can:delete-role']);
//Skill
Route::resource('skill','SkillController');
//Attribute
Route::resource('attribute','AttributeController');

Route::get('getAttribute','JobController@attribute')->name('getAttribute');

//API
Route::get('api-candidate/detail', 'Api\CandidateController@show')->name('api-candidate.detail');

Route::get('changeCandidate',"JobController@changeCandidate")->name('changeCandidate');
Route::post('rateCandidate','JobController@rateCandidate')->name('rateCandidate.create');

app/Skill.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Skill extends Model
{
    protected $fillable = ['name'];
    public function skills()
    {
        return $this->morphTo();
    }
    public function candidates()
    {
        return $this->morphedByMany('App\Candidate', 'skillable');
    }

    public function jobs()
    {
        return $this->morphedByMany('App\Job', 'skillable');
    }
}

app/Http/Controllers/SkillController.php
<?php

namespace App\Http\Controllers;

use App\Candidate;
use App\Job;
use App\Skill;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\App;

class SkillController extends Controller
{
    public function index(Request $request)
    {

        $skills = Skill::Query();
        if ($request->key) {
            $search = $request->key;
            $skills->where(function ($query) use ($search) {
                $query->where('name', 'like', '%' . $search . '%')->orWhere('email', 'like', '%' . $search . '%');
            });
        }
        $skills = $skills->paginate(PER_PAGE);
        return view('admin.skill.index',[
            'skills' => $skills,
        ]);
    }
    public function create()
    {
        return view('admin.skill.create');
    }

    public function store(Request $request)
    {
        $data = $request->all();
        $skills = new Skill();
        $skills->fill($data)->save();
        return redirect()->route('skill.index')->with('success', 'Create Success');
    }

    public function edit($id)
    {
        $skills = Skill::findorFail($id);
        return view('admin.skill.edit', [
            'skills' => $skills,
        ]);
    }

    public function update(Request $request, $id)
    {
        $data = $request->all();
        $skills = Skill::find($id);
        $skills->fill($data)->save();
        return redirect()->route('skill.index')->with('success', 'Edit Success');
    }

    public function destroy($id)
    {

       ;
    }
}

resources/views/admin/skill/create.blade.php
@extends('admin.layout.main')
@section('content')
    <!-- Content Header (Page header) -->
    <div class="content-header">
        <div class="container-fluid" style="padding: 11px;">
            <div class="row mb-2">
                <div class="">
                    <ol class="breadcrumb float-sm-right">
                        <li class="breadcrumb-item"><a href="{{route('admin.index')}}">Home</a></li>
                        <li class="breadcrumb-item"><a href="{{route('skill.index')}}">List</a></li>
                        <li class="breadcrumb-item active"><a href="{{route('skill.create')}}">Add</a></li>
                    </ol>
                </div>
                <div class=" col-sm-12">
                    <div class="table-data__tool-right" style="position: absolute;right: 0px;top: -25px;">
                        <a href="{{route('skill.index')}}">
                            <button type="button" class="btn btn-info"><i class="fas fa-th-list mr-2"></i>List
                            </button>
                        </a>
                    </div>
                </div>
            </div><!-- /.row -->
        </div><!-- /.container-fluid -->


        {{--Form Create--}}
        <div class="row" style="padding: 2px;">
            <div class="col-lg-12">
                <div class="card">
                    <div class="card-header">
                        <strong style="font-family: 'Open Sans', sans-serif;">Create Skill</strong>
                    </div>
                    <div class="card-body card-block">
                        <form action="{{route('skill.store')}}" method="post" enctype="multipart/form-data"
                              class="form-horizontal">
                            @csrf
                            <div class="form-group">
                                <label for="text-input" class=" form-control-label">Name</label>
                                <input value="{{old('name')}}" type="text"
                                       class="form-control @error('name') is-invalid @enderror" name="name"
                                       placeholder="Nhập tên đầy đủ">
                                @error('name')
                                <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                @enderror
                            </div>

                            <div style="margin-left: 921px;background-color: white;">
                                <button type="submit" class="btn btn-primary">Tạo</button>
                                <input type="reset" class="btn btn-default pull-right" value="Reset">
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/admin/skill/edit.blade.php
@extends('admin.layout.main')
@section('content')
    <!-- Content Header (Page header) -->
    <div class="content-header">
        <div class="container-fluid" style="padding: 11px;">
            <div class="row mb-2">
                <div class="">
                    <ol class="breadcrumb float-sm-right">
                        <li class="breadcrumb-item"><a href="{{route('admin.index')}}">Home</a></li>
                        <li class="breadcrumb-item"><a href="{{route('skill.index')}}">List</a></li>
                        <li class="breadcrumb-item active"><a href="">Edit</a></li>
                    </ol>
                </div>
                <div class=" col-sm-12">
                    <div class="table-data__tool-right" style="position: absolute;right: 0px;top: -25px;">
                        <a href="{{route('skill.index')}}">
                            <button type="button" class="btn btn-info"><i class="fas fa-th-list mr-2"></i>List
                            </button>
                        </a>
                    </div>
                </div>
            </div><!-- /.row -->
        </div><!-- /.container-fluid -->


        {{--Form Create--}}
        <div class="row" style="padding: 2px;">
            <div class="col-lg-12">
                <div class="card">
                    <div class="card-header">
                        <strong style="font-family: 'Open Sans', sans-serif;">Edit Role</strong>
                    </div>
                    <div class="card-body card-block">
                        <form action="{{route('skill.update',['id'=>$skills->id])}}" method="post"
                              enctype="multipart/form-data"
                              class="form-horizontal">
                            @csrf
                            @method('PUT')
                            <div class="form-group">
                                <label for="email-input" class=" form-control-label">Name</label>
                                <input value="{{$skills->name}}" type="text"
                                       class="form-control @error('name') is-invalid @enderror" name="name"
                                       placeholder="Nhập tên đầy đủ">
                                @error('name')
                                <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                @enderror
                            </div>
                            <div style="margin-left: 921px;background-color: white; ">
                                <button type="submit" class="btn btn-primary">Sửa</button>
                                <input type="reset" class="btn btn-default pull-right" value="Reset">
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/admin/skill/index.blade.php
@extends('admin.layout.main')
@section('content')
    @if (session()->has('success'))
        <div class="alert alert-success">
            @if(is_array(session('success')))
                @foreach (session('success') as $message)
                    {{ $message }}
                @endforeach
            @else
                {{ session('success') }}
            @endif
        </div>
    @endif
    <!-- Content Header (Page header) -->
    <div class="content-header">
        <div class="container-fluid">
            <div class="row mb-2">
                <div class="col-sm-6">
                    <h1 class="m-0 text-dark" style="font-family: 'Open Sans', sans-serif;">Skill</h1>
                </div>
            </div><!-- /.row -->

        </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->
    <!-- MAIN CONTENT-->
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header" style=" border-bottom: none !important;  width: 30%;">
                    <!-- Search form -->
                    <form style="margin-left: -49px;"
                          class="form-inline d-flex justify-content-center md-form form-sm active-purple active-purple-2 mt-2">
                        <input class="form-control form-control-sm ml-3 w-75" type="text" placeholder="Search"
                               aria-label="Search" @if(Request::get('key')) value="{{Request::get('key')}}"
                               @endif name="key">
                    </form>
                </div>
                <!-- /.card-header -->
                <div class="card-body">
                    <table class="table table-bordered">
                        <thead>
                        <tr style="text-align: center;">
                            <th>ID</th>
                            <th>Name</th>
                            <th style="width: 20%;">Action</th>
                        </tr>
                        </thead>
                        <tbody>
                        @foreach($skills as $skill)
                            <tr style="text-align: center;">
                                <td>{{$skill->id}}</td>
                                <td>{{$skill->name}}</td>
                                <td style="padding: 20px; flex-wrap: wrap;display: flex;justify-content: center;align-items: center;">
                                    {{--                                    @can('edit-user')--}}
                                    <a href="{{route('skill.edit',['id'=>$skill->id])}}" class="btn btn-info btn-sm">
                                        <i class="fas fa-pencil-alt"></i>
                                        Edit </a>
                                    {{--                                    @endcan--}}
                                    <form action="{{route('skill.destroy',['id'=>$skill->id])}}"
                                          onclick="return confirm('Có muốn xóa không mà xóa?')" method="post"
                                          style="margin: 2px;">
                                        @method('DELETE')
                                        @csrf
                                        <button type="submit" class="btn btn-danger btn-sm">
                                            <i class="fas fa-trash"></i>
                                            Delete
                                        </button>
                                    </form>

                                </td>
                            </tr>
                        @endforeach
                        </tbody>
                    </table>
                    <div class="d-flex" style="padding: 10px;">
                        <div class="mx-auto">
                            {{$skills->links()}}
                        </div>
                    </div>

                </div>
                <!-- /.card-body -->
            </div>
            <!-- /.card -->
        </div>
    </div>
    <!-- END DATA TABLE -->
@endsection